fs        = require "fs"
path      = require "path"
{logger}  = require "./utils"

log       = logger "config"

module.exports = class ConfigFile

  disabled: ["publicKey", "privateKey"]

  constructor: ->
    @configFile = path.join process.env.HOME, ".kdconfig"
    try
      @config = @load @configFile
    catch error
      @config = {}
      @save()

  get: (key)-> @config[key]
  set: (key, value...)-> @config[key] = value.join " "
  remove: (key)-> delete @config[key]

  getAll: -> @config

  save:->
    @disabled.forEach (item)=> @remove item
    fs.writeFileSync @configFile, (JSON.stringify @config, null, 2)

  load:->
    data = fs.readFileSync(@configFile).toString()
    @config = JSON.parse data