fs            = require "fs"
colors        = require "colors"
{ask, logger} = require "../lib/utils"

log           = logger "config"

module.exports = class Config

  alias:
    ls: "list"

  help:"""
  Koding configuration settings.
  """

  constructor: (@config)->

  set: (key, value...)->
    unless key and value
      return log "You must define a key and a value to set a config variable."
    @config.set key, value...
    @config.save()

  get: (path)->
    config = @config.getAll()
    try
      value = eval "config.#{path}"
    catch error
      log "Probably the path #{path} is wrong.", "red"
      process.exit 1

    unless value
      log "Config #{key} is not defined.", "red"
      process.exit 1

    console.log value

  remove: (path)->
    config = @config.getAll()
    # not a fancy way.
    try
      eval "delete config.#{path}"
    catch error
      log "Probably the path #{path} is wrong.", "red"
      process.exit 1
    
    # @config.remove key
    @config.save()

  list:->
    ask "Your config file may contain confidental information, do you want to list? [yN]",
      format: /[yN]/
      callback: (answer)=>
        if answer is "y"
          config = @config.getAll()
          @config.disabled.forEach (item)=> delete config[item]
          log JSON.stringify config, null, 2
        process.exit()

  alias: (alias, module)->
    return unless alias or module
    config = @config.getAll()
    config.alias = {} unless config.alias
    config.alias[alias] = module
    @config.save()

  # helper
  username: (callback, dontExit)->
    ask "#{colors.yellow "config:"} What is your Koding username? (Leave blank to set as #{colors.blue process.env.USER}):",
      format: /^([a-z\d]+([-][a-z\d]+)*){4,25}$|^$/i # from registration code
      callback: (answer)=>
        unless answer
          log "Setting your username to #{colors.green process.env.USER}", "blue"
          answer = process.env.USER
        @set "user.name", answer
        @set "username", answer
        callback() if typeof callback is "function"
        process.exit 0  unless dontExit

  # magic
  __command: (command)-> 
    @get command
