fs            = require "fs"
os            = require "os"
nodePath      = require "path"
url           = require "url"
colors        = require "colors"
shell         = require "shelljs"
{exec, spawn} = require "child_process"
Progress      = require "progress"
{logger}      = require "../lib/utils"
log           = logger "get"

module.exports = class Install
  
  help: """
  Koding KD CLI Installer Tool
  """

  __command: (repo, path)->

    installPath = path or process.cwd()

    fragments = repo.split /\/+/
    [username, repository] = fragments.slice -2

    unless username and repository
      throw "#{repo} doesn't look like an repo"

    repoDefaults =
      protocol: 'https'
      hostname: 'github.com'
    
    parsed = url.parse(repo)
    
    repo = url.format repoDefaults extends parsed

    log "Found: #{repo}", "magenta"

    tempFile = nodePath.join os.tmpDir(), "koding.kd.get.#{Math.random()}"
    repoPath = nodePath.join installPath, username, repository

    shell.mkdir "-p", installPath

    if shell.which "git"

      progress = new Progress "#{colors.yellow 'get:'} Downloading: [:bar] :percent :etas", 
        total: 5
        incomplete: " "
        width: 20

      clone = spawn "git", ["clone", "--recursive", repo, repoPath]
      clone.stdout.on "data", (data)-> progress.tick()
      clone.stderr.on "data", (data)-> progress.tick()
      clone.stdout.on "close", ->
        progress.tick progress.total - progress.curr
        process.exit 0
      clone.on "exit", (code)->
        progress.tick progress.total - progress.curr
        if code > 0
          console.log ""
          log "An error occured.", "red"
        process.exit code
    else
      log "Git not found. Please install it first."
      process.exit 1

